Index: squid/src/store_swapmeta.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapmeta.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.1
diff -u -r1.1.1.2 -r1.1.1.2.10.1
--- squid/src/store_swapmeta.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
+++ squid/src/store_swapmeta.c	17 Apr 2000 00:13:10 -0000	1.1.1.2.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapmeta.c,v 1.1.1.2 2000/01/26 03:25:01 hno Exp $
+ * $Id: store_swapmeta.c,v 1.1.1.2.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapfile Metadata
  * AUTHOR: Kostas Anagnostakis
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -64,11 +64,10 @@
 tlv *
 storeSwapMetaBuild(StoreEntry * e)
 {
-    MemObject *mem = e->mem_obj;
     tlv *TLV = NULL;		/* we'll return this */
     tlv **T = &TLV;
     const char *url;
-    assert(mem != NULL);
+    assert(e->mem_obj != NULL);
     assert(e->swap_status == SWAPOUT_WRITING);
     url = storeUrl(e);
     debug(20, 3) ("storeSwapMetaBuild: %s\n", url);
Index: squid/src/store_swapout.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapout.c,v
retrieving revision 1.1.1.3.4.1
retrieving revision 1.1.1.3.4.1.2.1
diff -u -r1.1.1.3.4.1 -r1.1.1.3.4.1.2.1
--- squid/src/store_swapout.c	4 Feb 2000 19:39:41 -0000	1.1.1.3.4.1
+++ squid/src/store_swapout.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapout.c,v 1.1.1.3.4.1 2000/02/04 19:39:41 hno Exp $
+ * $Id: store_swapout.c,v 1.1.1.3.4.1.2.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapout Functions
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -50,7 +50,7 @@
     char *buf;
     assert(mem);
     storeLockObject(e);
-    e->swap_file_number = storeDirMapAllocate();
+    storeSwapFileNumberSet(e, storeDirMapAllocate());
     c = xcalloc(1, sizeof(*c));
     c->data = e;
     cbdataAdd(c, cbdataXfree, 0);
@@ -58,8 +58,7 @@
 	O_WRONLY, storeSwapOutFileClosed, c);
     if (NULL == mem->swapout.sio) {
 	e->swap_status = SWAPOUT_NONE;
-	storeDirMapBitReset(e->swap_file_number);
-	e->swap_file_number = -1;
+	storeSwapFileNumberSet(e, -1);
 	cbdataFree(c);
 	storeUnlockObject(e);
 	return;
@@ -109,7 +108,10 @@
     lowest_offset = storeLowestMemReaderOffset(e);
     debug(20, 7) ("storeSwapOut: lowest_offset = %d\n",
 	(int) lowest_offset);
-    new_mem_lo = lowest_offset;
+    if (mem->inmem_hi - lowest_offset > DISK_PAGE_SIZE)
+        new_mem_lo = lowest_offset;
+    else
+        new_mem_lo = mem->inmem_lo;
     assert(new_mem_lo >= mem->inmem_lo);
     if (storeSwapOutAble(e)) {
 	/*
@@ -120,11 +122,11 @@
 	 */
 	if ((on_disk = storeSwapOutObjectBytesOnDisk(mem)) < new_mem_lo)
 	    new_mem_lo = on_disk;
-    } else {
+    } else if (new_mem_lo > 0) {
 	/*
-	 * Its not swap-able, so we must make it PRIVATE.  Even if
-	 * be only one MEM client and all others must read from
-	 * disk.
+	 * Its not swap-able, and we're about to delete a chunk,
+	 * so we must make it PRIVATE.  This is tricky/ugly because
+	 * for the most part, we treat swapable == cachable here.
 	 */
 	storeReleaseRequest(e);
     }
@@ -176,8 +178,7 @@
 	if (swap_buf_len < 0) {
 	    debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->key));
 	    storeUnlink(e->swap_file_number);
-	    storeDirMapBitReset(e->swap_file_number);
-	    e->swap_file_number = -1;
+	    storeSwapFileNumberSet(e, -1);
 	    e->swap_status = SWAPOUT_NONE;
 	    memFree(swap_buf, MEM_DISK_BUF);
 	    storeReleaseRequest(e);
@@ -233,21 +234,22 @@
     assert(e->swap_status == SWAPOUT_WRITING);
     cbdataFree(c);
     if (errflag) {
-	debug(20, 3) ("storeSwapOutFileClosed: swapfile %08X, errflag=%d\n\t%s\n",
-	    e->swap_file_number, errflag, xstrerror());
+	sfileno bad = e->swap_file_number;
+	debug(20, 1) ("storeSwapOutFileClosed: swapfile %08X, errflag=%d\n\t%s\n",
+	    bad, errflag, xstrerror());
+	storeSwapFileNumberSet(e, -1);
 	/*
-	 * yuck.  don't clear the filemap bit for some errors so that
+	 * yuck.  re-set the filemap bit for some errors so that
 	 * we don't try re-using it over and over
 	 */
-	if (errno != EPERM)
-	    storeDirMapBitReset(e->swap_file_number);
+	if (errno == EPERM)
+	    storeDirMapBitSet(bad);
 	if (errflag == DISK_NO_SPACE_LEFT) {
-	    storeDirDiskFull(e->swap_file_number);
+	    storeDirDiskFull(bad);
 	    storeDirConfigure();
 	    storeConfigure();
 	}
 	storeReleaseRequest(e);
-	e->swap_file_number = -1;
 	e->swap_status = SWAPOUT_NONE;
     } else {
 	/* swapping complete */
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.4.1.2.3
retrieving revision 1.1.1.3.4.1.2.4
diff -u -r1.1.1.3.4.1.2.3 -r1.1.1.3.4.1.2.4
--- squid/src/structs.h	15 Apr 2000 11:54:27 -0000	1.1.1.3.4.1.2.3
+++ squid/src/structs.h	17 Apr 2000 00:13:11 -0000	1.1.1.3.4.1.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.4.1.2.3 2000/04/15 11:54:27 asd Exp $
+ * $Id: structs.h,v 1.1.1.3.4.1.2.4 2000/04/17 00:13:11 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -10,10 +10,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -394,7 +394,6 @@
     } Netdb;
     struct {
 	int log_udp;
-	int enable_purge;
 #if USE_DNSSERVER
 	int res_defnames;
 #endif
@@ -506,6 +505,12 @@
 	int rebuild_chunk_percentage;
     } digest;
 #endif
+#if USE_DISKD
+    struct {
+	int magic1;
+	int magic2;
+    } diskd;
+#endif
 };
 
 struct _SquidConfig2 {
@@ -513,6 +518,9 @@
 	char *prefix;
 	int on;
     } Accel;
+    struct {
+	int enable_purge;
+    } onoff;
 };
 
 struct _close_handler {
@@ -1305,6 +1313,9 @@
     int id;
     ssize_t object_sz;
     size_t swap_hdr_sz;
+#if URL_CHECKSUM_DEBUG
+    unsigned int chksum;
+#endif
 };
 
 struct _StoreEntry {
@@ -1336,10 +1347,13 @@
     swapdir_t type;
     fileMap *map;
     int cur_size;
+    int low_size;
     int max_size;
     char *path;
     int index;			/* This entry's index into the swapDirs array */
-    int suggest;
+    sfileno suggest;
+    int removals;
+    int scanned;
     struct {
 	unsigned int selected:1;
 	unsigned int read_only:1;
@@ -1363,12 +1377,32 @@
 	    void *state;
 	} clean;
     } log;
+#if !HEAP_REPLACEMENT
+    dlink_list lru_list;
+    dlink_node *lru_walker;
+#endif
     union {
 	struct {
 	    int l1;
 	    int l2;
 	    int swaplog_fd;
 	} ufs;
+#if USE_DISKD
+	struct {
+	    int l1;
+	    int l2;
+	    int swaplog_fd;
+	    int smsgid;
+	    int rmsgid;
+	    int wfd;
+	    int away;
+	    struct {
+		char *buf;
+		link_list *stack;
+		int id;
+	    } shm;
+	} diskd;
+#endif
     } u;
 };
 
@@ -1434,6 +1468,16 @@
 	    link_list *pending_writes;
 	    link_list *pending_reads;
 	} aufs;
+#if USE_DISKD
+	struct {
+	    int id;
+	    struct {
+		unsigned int reading:1;
+		unsigned int writing:1;
+	    } flags;
+	    char *read_buf;
+	} diskd;
+#endif
     } type;
 };
 
@@ -1552,6 +1596,8 @@
 	int clients;
 	int requests;
 	int hits;
+	int mem_hits;
+	int disk_hits;
 	int errors;
 	kb_t kbytes_in;
 	kb_t kbytes_out;
@@ -1847,3 +1893,11 @@
     int bad_log_op;
     int zero_object_sz;
 };
+
+struct _Logfile {
+    int fd;
+    char path[MAXPATHLEN];
+    char *buf;
+    size_t bufsz;
+    off_t offset;
+};
Index: squid/src/test_cache_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/test_cache_digest.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.14.1
diff -u -r1.1.1.1 -r1.1.1.1.14.1
--- squid/src/test_cache_digest.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/src/test_cache_digest.c	17 Apr 2000 00:13:11 -0000	1.1.1.1.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: test_cache_digest.c,v 1.1.1.1 2000/01/26 03:21:47 hno Exp $
+ * $Id: test_cache_digest.c,v 1.1.1.1.14.1 2000/04/17 00:13:11 hno Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -11,10 +11,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/tools.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/tools.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: tools.c,v 1.1.1.3.10.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -876,7 +876,6 @@
     return p;
 }
 
-
 /*
  * Same as rename(2) but complains if something goes wrong;
  * the caller is responsible for handing and explaining the 
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.12.1
retrieving revision 1.1.1.3.12.2
diff -u -r1.1.1.3.12.1 -r1.1.1.3.12.2
--- squid/src/typedefs.h	14 Apr 2000 23:09:53 -0000	1.1.1.3.12.1
+++ squid/src/typedefs.h	17 Apr 2000 00:13:11 -0000	1.1.1.3.12.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.1.1.3.12.1 2000/04/14 23:09:53 hno Exp $
+ * $Id: typedefs.h,v 1.1.1.3.12.2 2000/04/17 00:13:11 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -10,10 +10,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -31,6 +31,9 @@
  *
  */
 
+#ifndef _TYPEDEFS_H_
+#define _TYPEDEFS_H_
+
 typedef unsigned int store_status_t;
 typedef unsigned int mem_status_t;
 typedef unsigned int ping_status_t;
@@ -165,6 +168,7 @@
 typedef struct _generic_cbdata generic_cbdata;
 typedef struct _storeIOState storeIOState;
 typedef struct _link_list link_list;
+typedef struct _Logfile Logfile;
 
 #if SQUID_SNMP
 typedef variable_list *(oid_ParseFn) (variable_list *, snint *);
@@ -266,3 +270,5 @@
 #if USE_HTCP
 typedef struct _htcpReplyData htcpReplyData;
 #endif
+
+#endif /* _TYPEDEFS_H_ */
Index: squid/src/unlinkd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/unlinkd.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.12.1
diff -u -r1.1.1.3 -r1.1.1.3.12.1
--- squid/src/unlinkd.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/unlinkd.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.12.1
@@ -1,5 +1,5 @@
 /*
- * $Id: unlinkd.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: unlinkd.c,v 1.1.1.3.12.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 12    Unlink Daemon
  * AUTHOR: Duane Wessels
@@ -11,10 +11,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.12.1
diff -u -r1.1.1.3 -r1.1.1.3.12.1
--- squid/src/url.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/url.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.12.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: url.c,v 1.1.1.3.12.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/urn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/urn.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/urn.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/urn.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.10.1
@@ -1,7 +1,7 @@
 
 /*
  *
- * $Id: urn.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: urn.c,v 1.1.1.3.10.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 52    URN Parsing
  * AUTHOR: Kostas Anagnostakis
@@ -13,10 +13,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/useragent.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/useragent.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/useragent.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/useragent.c	17 Apr 2000 00:13:11 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: useragent.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: useragent.c,v 1.1.1.3.10.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 40    User-Agent logging
  * AUTHOR: Joe Ramey <ramey@csc.ti.com>
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -35,31 +35,20 @@
 
 #include "squid.h"
 
+#if USE_USERAGENT_LOG
+static Logfile *useragentlog = NULL;
+#endif
+
 void
 useragentOpenLog(void)
 {
 #if USE_USERAGENT_LOG
-    char *fname = NULL;
-    int log_fd = -1;
-    fname = Config.Log.useragent;
-    /* Close and reopen the log.  It may have been renamed "manually"
-     * before HUP'ing us. */
-    if (cache_useragent_log) {
-	file_close(fileno(cache_useragent_log));
-	fclose(cache_useragent_log);
-	cache_useragent_log = NULL;
-    }
-    if (fname && strcmp(fname, "none") != 0) {
-	log_fd = file_open(fname, O_WRONLY | O_CREAT | O_APPEND);
-	if (log_fd < 0) {
-	    debug(50, 0) ("useragentOpenLog: %s: %s\n", fname, xstrerror());
-	} else if ((cache_useragent_log = fdopen(log_fd, "a")) == NULL) {
-	    file_close(log_fd);
-	    debug(50, 0) ("useragentOpenLog: %s: %s\n", fname, xstrerror());
-	}
-    }
-    if (log_fd < 0 || cache_useragent_log == NULL)
+    assert(NULL == useragentlog);
+    if (0 == strcmp(Config.Log.useragent, "none")) {
 	debug(40, 1) ("User-Agent logging is disabled.\n");
+	return;
+    }
+    logfileOpen(Config.Log.useragent, 0);
 #endif
 }
 
@@ -67,39 +56,9 @@
 useragentRotateLog(void)
 {
 #if USE_USERAGENT_LOG
-    char *fname = NULL;
-    int i;
-    LOCAL_ARRAY(char, from, MAXPATHLEN);
-    LOCAL_ARRAY(char, to, MAXPATHLEN);
-    struct stat sb;
-    if ((fname = Config.Log.useragent) == NULL)
-	return;
-    if (strcmp(fname, "none") == 0)
+    if (NULL == useragentlog)
 	return;
-#ifdef S_ISREG
-    if (stat(fname, &sb) == 0)
-	if (S_ISREG(sb.st_mode) == 0)
-	    return;
-#endif
-    debug(40, 1) ("useragentRotateLog: Rotating.\n");
-    /* Rotate numbers 0 through N up one */
-    for (i = Config.Log.rotateNumber; i > 1;) {
-	i--;
-	snprintf(from, MAXPATHLEN, "%s.%d", fname, i - 1);
-	snprintf(to, MAXPATHLEN, "%s.%d", fname, i);
-	xrename(from, to);
-    }
-    if (cache_useragent_log) {
-	file_close(fileno(cache_useragent_log));
-	fclose(cache_useragent_log);
-	cache_useragent_log = NULL;
-    }
-    /* Rotate the current log to .0 */
-    if (Config.Log.rotateNumber > 0) {
-	snprintf(to, MAXPATHLEN, "%s.%d", fname, 0);
-	xrename(fname, to);
-    }
-    useragentOpenLog();
+    logfileRotate(useragentlog);
 #endif
 }
 
@@ -110,18 +69,16 @@
     static time_t last_time = 0;
     static char time_str[128];
     const char *s;
-    if (!cache_useragent_log)
+    if (NULL == useragentlog)
 	return;
     if (squid_curtime != last_time) {
 	s = mkhttpdlogtime(&squid_curtime);
 	strcpy(time_str, s);
 	last_time = squid_curtime;
     }
-    fprintf(cache_useragent_log, "%s [%s] \"%s\"\n",
+    logfilePrintf(useragentlog, "%s [%s] \"%s\"\n",
 	client,
 	time_str,
 	agent);
-    if (!Config.onoff.buffered_logs)
-	fflush(cache_useragent_log);
 #endif
 }
Index: squid/src/wais.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wais.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.14.1
diff -u -r1.1.1.2 -r1.1.1.2.14.1
--- squid/src/wais.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/wais.c	17 Apr 2000 00:13:11 -0000	1.1.1.2.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wais.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: wais.c,v 1.1.1.2.14.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 24    WAIS Relay
  * AUTHOR: Harvest Derived
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/wccp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wccp.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.1
diff -u -r1.1.1.1 -r1.1.1.1.10.1
--- squid/src/wccp.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
+++ squid/src/wccp.c	17 Apr 2000 00:13:11 -0000	1.1.1.1.10.1
@@ -1,8 +1,8 @@
 
 /*
- * $Id: wccp.c,v 1.1.1.1 2000/01/26 03:25:01 hno Exp $
+ * $Id: wccp.c,v 1.1.1.1.10.1 2000/04/17 00:13:11 hno Exp $
  *
- * DEBUG: section 80     WCCP Support
+ * DEBUG: section 80    WCCP Support
  * AUTHOR: Glenn Chisholm
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -211,7 +211,7 @@
 {
     struct sockaddr_in from;
     socklen_t from_len;
-    int len;
+    size_t len;
 
     debug(80, 6) ("wccpHandleUdp: Called.\n");
 
@@ -223,7 +223,7 @@
     Counter.syscalls.sock.recvfroms++;
 
     len = recvfrom(sock,
-	&wccp_i_see_you,
+	(void *) &wccp_i_see_you,
 	WCCP_RESPONSE_SIZE,
 	0,
 	(struct sockaddr *) &from,
Index: squid/src/whois.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/whois.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.14.1
diff -u -r1.1.1.2 -r1.1.1.2.14.1
--- squid/src/whois.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/whois.c	17 Apr 2000 00:13:11 -0000	1.1.1.2.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: whois.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: whois.c,v 1.1.1.2.14.1 2000/04/17 00:13:11 hno Exp $
  *
  * DEBUG: section 75    WHOIS protocol
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
